/*******************************************************************************
 * Copyright (c) 2010 itemis AG (http://www.itemis.eu) and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *******************************************************************************/
package org.eclipse.xtext.ui.refactoring.impl;

import org.eclipse.emf.common.util.URI;
import org.eclipse.ltk.core.refactoring.participants.RenameProcessor;
import org.eclipse.xtext.ui.refactoring.IRenameElementStrategy;

import com.google.inject.ImplementedBy;

/**
 * Unfortunately LTK only defines abstract classes, so this is an abstract class instead of an interface only.
 * 
 * @author koehnlein - Initial contribution and API
 */
@ImplementedBy(RenameElementProcessor.class)
public abstract class AbstractRenameElementProcessor extends RenameProcessor {

	public abstract void initialize(URI targetElementURI);

	public abstract IRenameElementStrategy getRenameElementStrategy();

	public abstract void setNewName(String newName);
}
